
/**
 * This PurseTester has 11 tests. Most of them have been commented
 * out to allow the basic Purse class to compile and run. As you
 * write the Purse class, uncomment tests for new features so that
 * you can check your progress.
 *
 * @author Richard White
 * @version 2023-11-27
 */

import java.util.ArrayList;

public class PurseTester
{
    public static void main(String[] args)
    {
        int testsPassed = 0;
        
        System.out.print("Constructing a Purse object...");
        Purse p = new Purse();
        System.out.println("passed.");
        testsPassed++;
        
        /*
        System.out.print("\nAdding a coin with the .addCoin() method...");
        p.addCoin("quarter");
        System.out.println("passed.");
        testsPassed++;
        
        System.out.print("\nAdding coins and testing toString()...");
        p.addCoin("nickel");
        p.addCoin("penny");
        if (p.toString().equals("Purse[quarter,nickel,penny]"))
        {
            System.out.println("passed");
            System.out.println("with result: " + p);
            testsPassed++;
        }
        else
        {
            System.out.println("failed");
            System.out.println("Expected Purse[quarter,nickel,penny]");
        }
        
        System.out.print("\nTesting toString() method with an empty purse...");
        Purse p7 = new Purse();
        if (p7.toString().equals("Purse[]"))
        {
            System.out.println("passed");
            System.out.println("with result: " + p7);
            testsPassed++;
        }
        else
        {
            System.out.println("failed");
            System.out.println("Expected Purse[] and got " + p7);
        }
        
        System.out.print("\nTesting reverse method...");
        p.reverse();
        if (p.toString().equals("Purse[penny,nickel,quarter]"))
        {
            System.out.println("passed");
            System.out.println("with result: Purse[penny,nickel,quarter]");
            testsPassed++;
        }
        else
        {
            System.out.println("failed");
            System.out.println("Got result: " + p.toString());
            System.out.println("Expected Purse[penny,nickel,quarter]");
        }
        
        System.out.println("\nTesting transfer method...");
        Purse p5 = new Purse(); Purse p6 = new Purse();
        p5.addCoin("dime"); p6.addCoin("nickel"); p6.addCoin("penny");
        System.out.println("Original purse: " + p5);
        System.out.println("Purse to transfer from: " + p6);
        p5.transfer(p6);
        System.out.println("New 'to' purse: " + p5);
        System.out.println("New 'from' purse: " + p6);
        if ((p5.toString().equals("Purse[dime,nickel,penny]") ||
             p5.toString().equals("Purse[dime,penny,nickel]")) &&
             p6.toString().equals("Purse[]" ))
        {
            System.out.println("Coins transferred correctly.");
            testsPassed++;
        }
        else
        {
            System.out.println("failed. Coins incorrectly transferred.");
        }
        
        System.out.print("\nTesting same order method for identical purses...");
        Purse p2 = new Purse(); Purse p3 = new Purse(); Purse p4 = new Purse();
        p2.addCoin("dime"); p3.addCoin("dime"); p4.addCoin("dime");
        p2.addCoin("nickel"); p3.addCoin("nickel"); p4.addCoin("penny");
        p2.addCoin("penny"); p3.addCoin("penny"); p4.addCoin("nickel");
        if (p2.sameOrder(p3))
        {
            System.out.println("passed. Correctly identified same order.");
            testsPassed++;
        }
        else
        {
            System.out.println("failed. Didn't recognize purses with same order.");
        }
        
        System.out.print("\nTesting same order method for different purses...");
        if (!p2.sameOrder(p4))
        {
            System.out.println("passed. Correctly identified different purses as having different order.");
            testsPassed++;
        }
        else
        {
            System.out.println("failed. Thought that two purses with different order were the same.");
        }
        
        System.out.print("\nTesting same coins method for purses of different sizes...");
        Purse p8 = new Purse(); Purse p9 = new Purse(); Purse p10 = new Purse();
        p8.addCoin("dime"); p9.addCoin("dime"); p10.addCoin("dime");
        p8.addCoin("nickel"); p9.addCoin("penny"); p10.addCoin("nickel");
        p8.addCoin("penny"); p9.addCoin("nickel"); p10.addCoin("nickel");
        p8.addCoin("penny"); p10.addCoin("penny");
        
        if (!p8.sameCoins(p9))
        {
            System.out.println("passed. Recognized purses of different sizes as not having same coins.");
            testsPassed++;
        }
        else
        {
            System.out.println("failed. Didn't recognize purses with same coins.");
        }
        
        System.out.print("\nTesting same coins method for identical purses...");
        p9.addCoin("penny"); 
        if (p8.sameCoins(p9))
        {
            System.out.println("passed. Correctly identified same coins.");
            testsPassed++;
        }
        else
        {
            System.out.println("failed. Didn't recognize purses with same coins.");
        }
        
        System.out.print("\nTesting same coins method for different purses...");
        if (!p8.sameCoins(p10))
        {
            System.out.println("passed. Correctly identified different purses as having different coins.");
            testsPassed++;
        }
        else
        {
            System.out.println("failed. Thought that two purses with different coins were the same.");
        }
        */
       
        System.out.println("Tests passed: " + testsPassed + "/11");
    }
}
